diff --git a/Documentation/devicetree/bindings/media/i2c/adv7343.txt b/Documentation/devicetree/bindings/media/i2c/adv7343.txt
new file mode 100644
index 0000000..1d2e854
--- /dev/null
+++ b/Documentation/devicetree/bindings/media/i2c/adv7343.txt
@@ -0,0 +1,54 @@
+* Analog Devices adv7343 video encoder
+
+The ADV7343 are high speed, digital-to-analog video encoders in a 64-lead LQFP
+package. Six high speed, 3.3 V, 11-bit video DACs provide support for composite
+(CVBS), S-Video (Y-C), and component (YPrPb/RGB) analog outputs in standard
+definition (SD), enhanced definition (ED), or high definition (HD) video
+formats.
+
+Required Properties :
+- compatible: Must be "ad,adv7343"
+
+Optional Properties :
+- ad,adv7343-power-mode-sleep-mode: on enable the current consumption is
+				     reduced to micro ampere level. All DACs and
+				     the internal PLL circuit are disabled.
+- ad,adv7343-power-mode-pll-ctrl: PLL and oversampling control. This control
+				   allows internal PLL 1 circuit to be powered
+				   down and the oversampling to beswitched off.
+- ad,adv7343-power-mode-dac-1: power on/off DAC 1, 0 = OFF and 1 = ON.
+- ad,adv7343-power-mode-dac-2: power on/off DAC 2, 0 = OFF and 1 = ON.
+- ad,adv7343-power-mode-dac-3: power on/off DAC 3, 0 = OFF and 1 = ON.
+- ad,adv7343-power-mode-dac-4: power on/off DAC 4, 0 = OFF and 1 = ON.
+- ad,adv7343-power-mode-dac-5: power on/off DAC 5, 0 = OFF and 1 = ON.
+- ad,adv7343-power-mode-dac-6: power on/off DAC 6, 0 = OFF and 1 = ON.
+- ad,adv7343-sd-config-dac-out-1: Configure SD DAC Output 1.
+- ad,adv7343-sd-config-dac-out-2: Configure SD DAC Output 2.
+
+Example:
+
+i2c0@1c22000 {
+	...
+	...
+
+	adv7343@2a {
+		compatible = "ad,adv7343";
+		reg = <0x2a>;
+
+		port {
+			adv7343_1: endpoint {
+					ad,adv7343-power-mode-sleep-mode;
+					ad,adv7343-power-mode-pll-ctrl;
+					ad,adv7343-power-mode-dac-1;
+					ad,adv7343-power-mode-dac-2;
+					ad,adv7343-power-mode-dac-3;
+					ad,adv7343-power-mode-dac-4;
+					ad,adv7343-power-mode-dac-5;
+					ad,adv7343-power-mode-dac-6;
+					ad,adv7343-sd-config-dac-out-1;
+					ad,adv7343-sd-config-dac-out-2;
+			};
+		};
+	};
+	...
+};
diff --git a/drivers/media/i2c/adv7343.c b/drivers/media/i2c/adv7343.c
index 7606218..22ee6f4 100644
--- a/drivers/media/i2c/adv7343.c
+++ b/drivers/media/i2c/adv7343.c
@@ -29,6 +29,7 @@
 #include <media/adv7343.h>
 #include <media/v4l2-device.h>
 #include <media/v4l2-ctrls.h>
+#include <media/v4l2-of.h>
 
 #include "adv7343_regs.h"
 
@@ -398,6 +399,59 @@ static int adv7343_initialize(struct v4l2_subdev *sd)
 	return err;
 }
 
+static struct adv7343_platform_data *
+adv7343_get_pdata(struct i2c_client *client)
+{
+	struct adv7343_platform_data *pdata;
+	struct device_node *np;
+
+	if (!IS_ENABLED(CONFIG_OF) || !client->dev.of_node)
+		return client->dev.platform_data;
+
+	np = v4l2_of_get_next_endpoint(client->dev.of_node, NULL);
+	if (!np)
+		return NULL;
+
+	pdata = devm_kzalloc(&client->dev, sizeof(struct adv7343_platform_data),
+			     GFP_KERNEL);
+	if (!pdata)
+		goto done;
+
+	pdata->mode_config.sleep_mode =
+		of_property_read_bool(np, "ad,adv7343-power-mode-sleep-mode");
+
+	pdata->mode_config.pll_control =
+		of_property_read_bool(np, "ad,adv7343-power-mode-pll-ctrl");
+
+	pdata->mode_config.dac_1 =
+		of_property_read_bool(np, "ad,adv7343-power-mode-dac-1");
+
+	pdata->mode_config.dac_2 =
+		of_property_read_bool(np, "ad,adv7343-power-mode-dac-2");
+
+	pdata->mode_config.dac_3 =
+		of_property_read_bool(np, "ad,adv7343-power-mode-dac-3");
+
+	pdata->mode_config.dac_4 =
+		of_property_read_bool(np, "ad,adv7343-power-mode-dac-4");
+
+	pdata->mode_config.dac_5 =
+		of_property_read_bool(np, "ad,adv7343-power-mode-dac-5");
+
+	pdata->mode_config.dac_6 =
+		of_property_read_bool(np, "ad,adv7343-power-mode-dac-6");
+
+	pdata->sd_config.sd_dac_out1 =
+		of_property_read_bool(np, "ad,adv7343-sd-config-dac-out-1");
+
+	pdata->sd_config.sd_dac_out2 =
+		of_property_read_bool(np, "ad,adv7343-sd-config-dac-out-2");
+
+done:
+	of_node_put(np);
+	return pdata;
+}
+
 static int adv7343_probe(struct i2c_client *client,
 				const struct i2c_device_id *id)
 {
@@ -416,7 +470,7 @@ static int adv7343_probe(struct i2c_client *client,
 		return -ENOMEM;
 
 	/* Copy board specific information here */
-	state->pdata = client->dev.platform_data;
+	state->pdata = adv7343_get_pdata(client);
 
 	state->reg00	= 0x80;
 	state->reg01	= 0x00;
@@ -476,8 +530,17 @@ static const struct i2c_device_id adv7343_id[] = {
 
 MODULE_DEVICE_TABLE(i2c, adv7343_id);
 
+#if IS_ENABLED(CONFIG_OF)
+static const struct of_device_id adv7343_of_match[] = {
+	{.compatible = "ad,adv7343", },
+	{ /* sentinel */ },
+};
+MODULE_DEVICE_TABLE(of, adv7343_of_match);
+#endif
+
 static struct i2c_driver adv7343_driver = {
 	.driver = {
+		.of_match_table = of_match_ptr(adv7343_of_match),
 		.owner	= THIS_MODULE,
 		.name	= "adv7343",
 	},